<?php

/***************************************************************************
 *   Copyright (C) 2005-2020 by Ferenc Veres							   *
 *   lion@netngine.hu													   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/
include('WebBackend.php');

$guiTime = GetMicroTime();
?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
<title>TranslationMemory</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<link rel="stylesheet" href="style.css" type="text/css" media="screen" />
<script type="text/javascript" src="script.js"></script>
<script type="text/javascript" src="diff.js"></script>
</head>
<body>
<?php
/**** Process postback events ***/


$backend = new WebBackend();
$backend->EventHandler();

?>
<form action="WebGUI.php" method="post" name="__Form" id="__Form">
<input type="hidden" name="__Event" value="" id="__Event" />

<!-- backend variables (documented in TranslationBackend class) -->
<input type="hidden" name="xStringID" value="<?php echo $backend->xStringID ?>" id="xStringID" />
<input type="hidden" name="xProjectID" value="<?php echo $backend->xProjectID ?>" id="xProjectID" />
<input type="hidden" name="xActiveRootID" value="<?php echo $backend->xActiveRootID ?>" id="xActiveRootID" />
<input type="hidden" name="xOldLocaleID" value="<?php echo $backend->xOldLocaleID ?>" id="xOldLocaleID" />

<input type="hidden" name="xStringStack" value="<?php echo $backend->xStringStack ?>" id="xStringStack" />
<input type="hidden" name="xBrowserHelper" value="<?php echo $backend->xBrowserHelper ?>" id="xBrowserHelper" />
<input type="hidden" name="xDelStringID" value="0" id="xDelStringID" />
<input type="hidden" name="xDelProjectID" value="0" id="xDelProjectID" />

<!-- client side variables -->

<!-- Editor field changed and operation requires confirmation -->
<input type="hidden" name="htmlEditorChanged" value="0" id="htmlEditorChanged" />

<!-- Value of the stack when this page was loaded, to mark older items -->
<input type="hidden" name="htmlPageLoadStack" value="<?php echo $backend->xStringStack ?>" id="htmlPageLoadStack" />

<!-- The English original of the current string, for diff.js comparison -->
<input type="hidden" name="htmlOriginalString" value="<?php
	if(!empty($backend->LocatedString))
	{
		echo FixQuot($backend->LocatedString->GetOriginal());
	}
	?>" id="htmlOriginalString"/>

<table class="layout"><!-- for ideal width -->
<tr><td valign="top">

	<!-- *** PROJECT TREE *** -->

<?php
// Show project tree ListItem
function showProjectLine(TranslationProject $proj, $c) {
	global $backend;
	// css class for current project
	$css = "";
	if($proj->GetID() == $backend->xProjectID)
	{
		$css = " class=\"current\"";
	}
	// Show UL and LI
	echo "<li$css><a href=\"javascript:__TriggerEvent('setproject', true, 'xProjectID','". $proj->GetID()."')\">";
	echo htmlspecialchars($proj->GetName());
	//echo "**$c***";
	echo "</a>";
	
	// Dead project? (Was not seen on last import.)
	if($proj->GetRootID() != 0
		&& $backend->RootProjects[$proj->GetRootID()]->GetLastSeen() > $proj->GetLastSeen())
	{
		echo " +";
	}
}

	if(!empty($backend->LocatedProjects))
	{
		$root = $backend->LocatedProjects[count($backend->LocatedProjects)-1];
		if($root->GetID() != $backend->xActiveRootID) {
			echo("<h1>Root switched to ".htmlspecialchars($root->GetName())."</h1>");
			echo("<h1>Root switched to ".htmlspecialchars($root->GetName())."</h1>");
			echo("<h1>Root switched to ".htmlspecialchars($root->GetName())."</h1>");
		}

		// Display project parents from root in nested LI-st.
		for($i = count($backend->LocatedProjects)-1; $i > 0; $i--)
		{
			// This leaves ULs and LIs open as each item is a new level!
			$css = ($i == count($backend->LocatedProjects)-1 ? " class=\"projecttree\"" : "");
			echo "<ul$css>\n";
			showProjectLine($backend->LocatedProjects[$i], "t");
		}

		// Display current project's level (siblings)
		if($backend->SiblingProjects->valid())
		{
			// This renders exactly one UL with multiple LIs and and the current-LI having a nested UL
			if(count($backend->LocatedProjects) == 1) 
			{
				echo "<ul class=\"projecttree\">\n";
			} else {
				echo "<ul>\n";
			}
			foreach($backend->SiblingProjects as $project)
			{
				showProjectLine($project,"s");

				// Current project, nest children!
				if($project->GetID() == $backend->xProjectID) {

					// Any childprojects in the iterator?
					if($backend->ChildProjects->valid())
					{
						echo "<ul>\n";
						foreach($backend->ChildProjects as $project)
						{
							showProjectLine($project,"c");
							echo("</li>\n");
						}
						echo "</ul>";
					}
				}
			}
		}

		// Close all opened ULs
		for($i = count($backend->LocatedProjects)-1; $i >= 0; $i--)
		{
			echo "</li>\n</ul>\n";
		}
	}
?>
</td>

<td valign="top">

	<!-- *** ONE STRING EDITOR *** -->

<?php
	// Show one string details if it was a locate event
	if(!empty($backend->LocatedString))
	{
		?>
		<h1>Translation string editor area</h1>

		<?php
		$stringIsDead = ($backend->GetProject()->GetRootID() != 0 
			&& $backend->RootProjects[$backend->GetProject()->GetRootID()]->GetLastSeen() > $backend->LocatedString->GetLastSeen());
		if($stringIsDead)
		{
			// Open a dark gray area
			echo("<p>Dead string, not editable.</p>");
			echo("<div class=\"located-dead\">");
		}
		?>
		<table class="located">
		<tr><th>Project Path</th>
		<td><?php 
	
		// Display project path
		if(!empty($backend->LocatedProjects))
		{
			for($i = count($backend->LocatedProjects)-1; $i >= 0; $i--)
			{
				// FIXME: Hardcoded Xaraya stuff
				$style = "";
				if($i == 0 && $backend->LocatedProjects[$i]->GetName() == "fuzzy.xml")
				{
					$style = "style=\"font-size: 25px\"";
				}

				// Display project path entries
				echo "<a $style href=\"javascript:__TriggerEvent('setproject', true, 'xProjectID','". $backend->LocatedProjects[$i]->GetID()."')\">";
				echo $backend->LocatedProjects[$i]->GetName();
				echo "</a>";
				if($i != 0)
				{
					echo " -&gt; ";
				}
			}
		}
		?></td></tr>
		<tr><th>Original</th>
		<td><?php echo FixQuot($backend->LocatedString->GetOriginal()) ?></td></tr>
		<tr><th><u>E</u>dit translation</th>
		<td><?php
			$disableField = ($stringIsDead ? "disabled=\"disabled\"" : "");
			// Long or short input fields for editing
			if(strlen($backend->LocatedString->GetOriginal()) < 100)
			{
				echo "<input spellcheck=\"true\" class=\"editshort\" type=\"text\" accesskey=\"e\" name=\"txtEditString_".$backend->xBrowserHelper."\" id=\"txtEditString_".$backend->xBrowserHelper."\" value=\"";
				echo FixQuot($backend->LocatedString->GetTranslation());
				echo "\" onchange=\"editorChanged();\" tabindex=\"1\" $disableField/>";
			}
			else
			{
				echo "<textarea class=\"editlong\" cols=\"80\" rows=\"8\" accesskey=\"e\" name=\"txtEditString_".$backend->xBrowserHelper."\" id=\"txtEditString_".$backend->xBrowserHelper."\" onchange=\"editorChanged();\" tabindex=\"1\" $disableField>";
				echo FixQuot($backend->LocatedString->GetTranslation());
				echo "</textarea>";
			}
		?>
		</td></tr>
		</table>
		<?php
		// Enable/disable various buttons
		$stackLength = 0;
		if($backend->xStringStack != "")
		{
			$stackLength = count(split(',', $backend->xStringStack));
		}
		$saveDisabled = "class=\"button-disabled\" disabled=\"disabled\"";
		$saveEnabled = "class=\"button\"";
		if($stringIsDead)
		{
			// Close dark gray area
			echo("</div>");

			$saveType = $saveDisabled;
			$saveTypePop = $saveDisabled;
		}
		else
		{
			$saveType = $saveEnabled;
			$saveTypePop = $saveEnabled;

			// If no stack disable "save + pop" and "save to all stacked"
			if($stackLength == 0)
			{
				$saveTypePop = $saveDisabled;
			}
		}
		?>
		<input <?php echo $saveType; ?> type="button" onclick="__TriggerEvent('savenext', false);" value="Save + Next" tabindex="2" />
		<button <?php echo $saveType; ?> type="button" onclick="__TriggerEvent('savenextmissing', false);" tabindex="3" accesskey="s"><u>S</u>ave + Next missing</button>
		<input <?php echo $saveType; ?> type="button" onclick="__TriggerEvent('save', false);" value="Save" tabindex="4" />
		<!-- input class="button" type="button" onclick="__TriggerEvent('previous');" value="Previous" />
		<input class="button" type="button" onclick="__TriggerEvent('previoumissing');" value="Previous missing" / -->
		<input class="button" type="button" onclick="__TriggerEvent('next', true);" value="Next" tabindex="5" />
		<button class="button" type="button" onclick="__TriggerEvent('nextmissing', true);" tabindex="6" accesskey="n" tabindex="6"><u>N</u>ext missing</button>
		
		Stack control: <button <?php echo $saveTypePop; ?> type="button" onclick="__TriggerEvent('savepopstack', false);" tabindex="7" accesskey="p" id="btnSavePopStack">Save + <u>p</u>op</button>
		<input <?php echo $saveType; ?> type="button" onclick="if(confirm('Operation will OVERWRITE all selected strings and current string!')) { __TriggerEvent('savetoallchecked', false); }" value="Save to all chekced" tabindex="8" />
		<?php
		}

?>
	<!-- *** STACK *** -->

<div id="stack">
<h1>Stack</h1>
Contents: [<span id="plhStackView"></span>]
<?php
if(!empty($backend->LocatedString))
{
	?>
	<input class="codebutton" type="button" onclick="pushToStack('<?php echo($backend->LocatedString->GetStringID()); ?>');" value="push" tabindex="7" />
	<?php
}
?>
<input class="codebutton" type="button" onclick="popFromStack();" value="pop" tabindex="9" />
<input class="codebutton" type="button" onclick="clearStack();" value="clear" tabindex="10" />
</div>
<?php

if(!empty($backend->CurrentStrings))
{
	?>
	
	<!-- *** CURRENT PROJECT'S STRINGS *** -->

	<p><a href="javascript:toggleStrings()" accesskey="t"><span class="underunder">t</span>oggle strings</a></p>
	<div id="divStrings">
	<h1>Strings in the currently selected file</h1>
	<?php

	$addHeader = true;
	foreach($backend->CurrentStrings as $str)
	{
		// Draw header if not done yet
		if($addHeader)
		{
			?>
			<table class="strings">
			<tr><th>Original string</th>
			<th>Translated string</th>
			<th>Action</th></tr>
			<?php
			$addHeader = false;
		}
		if(!empty($backend->LocatedString) && $backend->LocatedString->GetStringID() == $str->GetStringID())
		{
			echo("<tr class=\"selected\">");
		}
		else
		{
			echo("<tr>");
		}
		
		echo("<td class=\"string-original\">".FixQuot($str->GetOriginal())."</td>");
		echo("<td class=\"string-translation\">".FixQuot($str->GetTranslation())."</td>");
		echo("<td><a href=\"javascript:__TriggerEvent('editstring', true, 'xStringID','".$str->GetStringID()."');\">Edit</a>");
		
		// Dead string?
		if($backend->GetProject()->GetRootID() != 0
			&& $backend->RootProjects[$backend->GetProject()->GetRootID()]->GetLastSeen() > $str->GetLastSeen())
		{
			echo " +++ ";
			echo("<a href=\"javascript:if(confirm('Are you sure to delete from Translation Memory?')) { __TriggerEvent('deletestring', true, 'xDelStringID', '".$str->GetStringID()."'); }\">Del</a>");
		}

		echo("</td>");
		echo("</tr>\n");
	}
	if($addHeader)
	{
		// No strings for this project: "next" buttons only
		?>
		<p>There are no strings in the current project.</p>
		Find strings: <input class="button" type="button" onclick="__TriggerEvent('next', true);" value="Next" />
		<button class="button" type="button" onclick="__TriggerEvent('nextmissing', true);" accesskey="n"><u>N</u>ext missing</button>
		<?php
		
		// Deletion of empty and dead projects
		$backend->ChildProjects->rewind();

		if($backend->GetProject()->GetRootID() != 0 
			&& $backend->RootProjects[$backend->GetProject()->GetRootID()]->GetLastSeen() > $backend->GetProject()->GetLastSeen() 
			&& !$backend->ChildProjects->valid())
		{
			echo("<p>The <em>".$backend->GetProject()->GetName()."</em> is an empty and dead project. ");
			echo("<input class=\"button\" type=\"button\" onclick=\"javascript:if(confirm('Are you sure to delete from Translation Memory?')) { __TriggerEvent('deleteproject', false, 'xDelProjectID', '". $backend->GetProject()->GetID()."'); }\" value=\"Delete project\"/></p>");
		}

	}
	else
	{
		echo("</table>");
	}
	?></div><?php
}

$sel = " selected=\"selected\"";
?>	<h1>Search</h1><a name="searchresults"></a>

	<!-- *** CUSTOM SEARCH BOX *** -->

<p>
<select name="ddlSearchType" id="ddlSearchType">
<option value="0"<?php echo ($backend->ddlSearchType == 0 ? $sel : ""); ?>>Word index</option>
<option value="1"<?php echo ($backend->ddlSearchType == 1 ? $sel : ""); ?>>Part in original</option>
<option value="2"<?php echo ($backend->ddlSearchType == 2 ? $sel : ""); ?>>Part in translation</option>
</select>
<a href="javascript:clearFindText();">clear></a>
<input type="text"  size="35" id="txtFindText" name="txtFindText" value="<?php echo FixQuot( $backend->txtFindText); ?>">
<input class="button" type="button" value="Find" onclick="__TriggerEvent('find', true);"/>
<!-- input class="button" type="button" value="Original"/--></p>


	<!-- *** SEARCH RESULTS *** -->


<?php
// Show search results if there is any!
if(!empty($backend->Translations))
{
	$keyindex = 0;
	?>
	<table class="guesses" id="tblGuesses">
	<tr><th></th>
	<th>Match</th>
	<th>Original string</th>
	<?php
	if(!empty($backend->LocatedString))
	{
		echo("<th>alt</th>");
	}
	?>
	<th>Translated string (take by click)</th>
	<th>Action</th>
	<th>Root</th></tr>
	<?php

	$accesskeys = array("m"); // Was '1'-'9' but that switches tabs so only one now... https://code.google.com/p/chromium/issues/detail?id=21624
	foreach($backend->Translations as $id => $tr)
	{
		foreach($tr["strings"] as $key => $str)
		{
			// Selected color or normal table row
			if(!empty($backend->LocatedString) && $backend->LocatedString->GetStringID() == $str->GetStringID())
			{
				echo("<tr id=\"tr_search_".$str->GetStringID()."\" class=\"selected\">");
			}
			else
			{
				echo("<tr id=\"tr_search_".$str->GetStringID()."\">");
			}

			// Find string root project for dead string checks
			$strProject = ProjectIterator::$ProjectList[$str->GetLocaleID()][$str->GetProjectID()];
			$strRoot = $backend->RootProjects[$strProject->GetRootID()];

			// Checkbox column
			echo("<td class=\"guess-checkbox\">");
			if($strRoot->GetLastSeen() <= $str->GetLastSeen())
			{
				echo(" <input type=\"checkbox\" name=\"chkSearchSelects[]\" value=\"".$str->GetStringID()."\"/>");
			}
			echo("</td>");

			// Percent column
			if($backend->ddlSearchType == 0)
			{
				// Exact match? (Not only 100%, word index match, but same string.)
				if(!empty($backend->LocatedString) && $backend->LocatedString->GetOriginal() == $str->GetOriginal()) {
					echo("<td class=\"guess-identical\">");
					echo("identical");
				}
				else
				{
					echo("<td class=\"guess-percent\">");
					echo($tr["percent"]."%");
					echo(" <a id=\"diffLink_".$str->GetStringID()."\" href=\"javascript:diffToOriginal(".$str->GetStringID().");\">(?)</a>");
				}
			}
			else
			{
				echo("<td class=\"guess-percent\">");
			}
			echo("</td>");

			// String columns
			echo("<td id=\"original_".$str->GetStringID()."\" class=\"guess-original\">".FixQuot($str->GetOriginal())."</td>");
			
			// Add "Take string" link if editing one, no link otherwise
			if(!empty($backend->LocatedString))
			{
				// Accesskey 1-9
				echo("<td class=\"guess-accesskey\">");
				if($keyindex < count($accesskeys) && $str->GetTranslation() != "")
				{
					echo("<a accesskey=\"".$accesskeys[$keyindex]."\" href=\"javascript:takeTranslation(".$str->GetStringID().");\"><span class=\"underunder\">".$accesskeys[$keyindex]."</span></a>");
					$keyindex++;
				}
				echo("</td>");

				// Translation with take link
				echo("<td class=\"guess-translated\">");
				if($str->GetTranslation() != "")
				{
					echo("<a id=\"results_".$str->GetStringID()."\" href=\"javascript:takeTranslation(".$str->GetStringID().");\">".FixQuot($str->GetTranslation())."</a>");
				}
				echo("</td>");
			}
			else
			{
				// Not pickable translation
				echo("<td class=\"guess-translated\">");
				echo(FixQuot($str->GetTranslation()));
				echo("</td>");
			}
			
			echo("<td class=\"guess-action\">");

			// Edit link (for dead strings too, to identify them)
			echo("<a href=\"javascript:__TriggerEvent('editstring', true, 'xStringID', '".$str->GetStringID()."');\">Edit</a>");
			
			// Del link (for dead strings ) or push link otherwise
			if($strRoot->GetLastSeen() > $str->GetLastSeen())
			{
				// Plus sign and Del link
				echo " +++ ";
				echo("<a href=\"javascript:if(confirm('Are you sure to delete from Translation Memory?')) { __TriggerEvent('deletestring', true, 'xDelStringID', '".$str->GetStringID()."'); }\">Del</a>");
			}
			else
			{
				// Not dead, "push" to stack link
				echo(" | <a href=\"javascript:pushToStack('".$str->GetStringID()."');\">push</a>");
			}
			echo("</td>\n");
			echo("<td>".$strRoot->GetName()."</td></tr>\n");
		}
	}
	?></table><?php
	if($backend->ddlSearchType != 0)
	{
		echo("Displayed ".count($backend->Translations)." results.<br/>");
	}
}
?>

	<!-- *** SEARCH REFRESH CONTROLS *** -->

<select name="ddlFindPercent">
<?php
foreach(array(30,40,50,60,70,80,90) as $percent)
{
	$sel = "";
	if($backend->ddlFindPercent == $percent)
	{
		$sel = " selected=\"selected\"";
	}
	echo "<option value=\"$percent\"$sel>&gt; $percent%</option>";
}
?>
</select>
<input type="button" value="Refresh" class="button" onclick="__TriggerEvent('find', true);"/>
<input type="button" value="Check all identical empty" class="button" onclick="checkGuesses(false);" />
<input type="button" value="Uncheck all" class="button" onclick="checkGuesses(true);" />

</td>

</tr>
</table>
<div class="localeswitch">
<?php
	echo "<select name=\"ddlLocaleID\">\n";
	foreach(TranslationProject::$LocaleIDCache as $name => $id)
	{
		$sel = "";
		if($backend->ddlLocaleID == $id)
		{
			$sel = " selected=\"selected\"";
		}
		echo "<option value=\"$id\"$sel>$name</option>\n";
	}
	echo "</select>\n";
?>
<input type="button" value="Switch Locale" class="button" onclick="__TriggerEvent('setlocale', true);"/> |
<!-- Root project switch -->
<select name="ddlActiveRoot">
<?php
	foreach($backend->RootProjects as $id => $rootProject) 
	{
		$sel = ($backend->xActiveRootID == $id ? " selected=\"selected\"" : "");
		echo "<option value=\"$id\"$sel>".htmlspecialchars($rootProject->GetName())."</option>\n";
	}
?>
</select>
<input type="button" value="Switch Root" class="button" onclick="__TriggerEvent('setroot', true);"/> |

<?php if($CONFIG['enable_web_export']) { ?>
<input type="button" value="Export language pack" class="button" onclick="__TriggerEvent('exportpack', true);"/> |
<?php } ?>

<a href="http://xartm.xaraya.hu">Homepage</a> | <a href="doc/">Documentation</a> | (c) 2006-2020 Ferenc 'Lion/Kempelen' Veres
</div>
</form>

<script type="text/javascript">

// Clear eventhandler
document.getElementById('__Event').value = ''; 
document.getElementById('__Form').onsubmit = __FormSubmit(); 
STR_UNIQUE = "<?php echo $backend->xBrowserHelper ?>";

showStack();

<?php if(!empty($backend->LocatedString))
{
?>
	var txtEditString = document.getElementById('txtEditString_<?php echo $backend->xBrowserHelper; ?>');
	txtEditString.focus();
<?php
}
?>
</script>

<?php
ShowMicroTime($guiTime, "GUI");
?>
</body>
</html>
