#!/usr/bin/php
<?php
/***************************************************************************
 *   Copyright (C) 2005-2020 by Ferenc Veres							   *
 *   lion@netngine.hu													   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/
if(empty($argc))
{
	exit;
}
include_once('config.inc.php');
include_once('export/ExporterFactory.php');
include_once('lib/Common.php');

$DB = NewADOConnection(GetConfigVar('db_software'));
$DB->Connect(GetConfigVar('db_host'), GetConfigVar('db_username') , GetConfigVar('db_password'), GetConfigVar('db_database'));
$DB->Execute("SET NAMES utf8");
CacheIndexes();

// To export a translaiton

if($argc != 3 || empty(TranslationProject::$LocaleIDCache[$argv[1]]))
{
	echo "Usage: export.php localename projecttype\n";

	echo "Known locales:\n";
	foreach(TranslationProject::$LocaleIDCache as $name => $id)
	{
		echo " $name\n";
	}

	echo "Known project types:\n";
	if($argc >= 2 && !empty(TranslationProject::$LocaleIDCache[$argv[1]])) 
	{
		$locale = TranslationProject::$LocaleIDCache[$argv[1]];
		foreach(TranslationProject::GetRoots($locale) as $id => $proj)
		{
			echo " ".$proj->GetName()."\n";
		}
	}
	else
	{
		echo " (please specify locale name to list)\n";
	}

	exit;
}
$factory = new ExporterFactory();
$proc = $factory->NewExporter($argv[2]);
$proc->Export($argv[1]);

?>
