<?php

/***************************************************************************
 *   Copyright (C) 2005-2020 by Ferenc Veres							   *
 *   lion@netngine.hu													   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

/**
* Recreates the Xarigami locale files from the database
*
* Does exactly the opposite than TranslationImportXarigami. Note, that dead
* projects won't be exported. 
* 
* Exporting will try to find corresponding 
* php/xt/xd files for the created XML files and write a note to xartm_errors.txt
* if no corresponding code file can be found. Unless you know the purpose
* of the reported XML file (e.g. it's a module you currently did not install to the 
* export directory's Xaraya), you should delete those .xml files.
*/

class TranslationExportXarigami extends TranslationExportXaraya
{
	function __construct() 
	{
		$this->ProjectName = "Xarigami";
		$this->XmlNameSpace = "http://xarigami.com/2011/ns/translations";
	}
}
