<?php

/***************************************************************************
 *   Copyright (C) 2005-2020 by Ferenc Veres							   *
 *   lion@netngine.hu													   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/
/**
 * Class to store one single word in a sentence, including its count of occurences.
 *
 * This simple class can store one single word, an occurence counter for it and the
 * word's ID in the WordIndex database.
 */

class TranslationWord
{
	private $ID;		/**< Word's ID in the WordIndex database */
	private $Word;		/**< The word's text */
	private $Count;		/**< Number of occurences in the current context */

	/**
	* Create an empy word.
	*/
	
	function __construct()
	{
		$this->ID = 0;
		$this->Word = "";
		$this->Count = 0;
	}

	/**
	* Set the WordIndex ID of this word.
	*/
	function SetID($id)
	{
		$this->ID = $id;
	}
	
	/**
	* Get the WordIndex ID of this word.
	*/
	function GetID()
	{
		return $this->ID;
	}

	/**
	* Set this word's actual text.
	*/
	function SetWord($word)
	{
		$this->Word = $word;
	}
	
	/**
	* Get this word's actual text.
	*/
	function GetWord()
	{
		return $this->Word;
	}

	/**
	* Set the occurences of this word in your sentence.
	*/
	function SetCount($count)
	{
		$this->Count = $count;
	}
	
	/**
	* Get the occurences of this word in your sentence.
	*/
	function GetCount()
	{
		return $this->Count;
	}
}
?>
