// JavaScript for xartm WebGUI.php

// Suffix for the browser string editor field: md5 of the string, 
// so browsers will offer the same history for the same strigns. 
// (xBrowserHelper variable form the backend)
var STR_UNIQUE; 

// Set default Event for plain submit
function __FormSubmit()
{
	if(document.getElementById('__Event').value == '')
	{
		document.getElementById('__Event').value = 'find';
	}
}
// Trigger the specified event, fill hidden variables with name,value pairs from variable args list.
function __TriggerEvent(event, confirmEvent, args)
{
	// If field changed, confirm wanted, and not confirmed: cancel operation
	if(document.getElementById('htmlEditorChanged').value == "1" &&
		confirmEvent &&
		!confirm("Discard current editing?"))
	{
		return;
	}

	// Copy custom arguments to object values (the only supported method)
	for(i=2;i<arguments.length;i+=2)
	{
		document.getElementById(arguments[i]).value = arguments[i+1];
	}
	
	document.getElementById('__Event').value = event;
	document.getElementById('__Form').submit();
}

/* EDITING FUNCTIONS */

// Copy a translation from the search results to current editor
function takeTranslation(stringID)
{
	translation = document.getElementById('results_' + stringID).innerHTML;
	
	// Fix some entities and such
	translation = fixHtmlTags(translation);

	document.getElementById('txtEditString_' + STR_UNIQUE).value = translation;
	editorChanged();

	// Move focus and window to editor
	window.scroll(0,0);
	var txtEditString = document.getElementById('txtEditString_' + STR_UNIQUE);
	txtEditString.focus();
	
}

// Fix some entities and such things when picking string from TD contents
function fixHtmlTags(str)
{
	str = str.replace(/\n/g, " ");
	str = str.replace(/\&gt;/g, ">");
	str = str.replace(/\&lt;/g, "<");
	str = str.replace(/\&amp;/g, "&");
	
	return str;
}

// Show or hide the strings table.
function toggleStrings()
{
	if(document.getElementById('divStrings').style.display == 'none')
	{
		document.getElementById('divStrings').style.display = 'block';
	}
	else
	{
		document.getElementById('divStrings').style.display = 'none';
	}
}

// Called when user types in some translation, to confirm losing it.
function editorChanged()
{
	document.getElementById('htmlEditorChanged').value = "1";
}

// Clear the search box
function clearFindText()
{
	document.getElementById('txtFindText').value = "";
}

// Show DIFF-erences to the original string from a picked one
function diffToOriginal(stringID)
{
	// Compare to this
	var testedString = fixHtmlTags(document.getElementById('original_' + stringID).innerHTML);

	// This is the original (if found while displaying search results!)
	var masterString = document.getElementById('htmlOriginalString').value;
	if(masterString == "")
	{
		alert("There is no current string selected to comapre to.");
		return;
	}

	document.getElementById('original_' + stringID).innerHTML = StringDiff(testedString, masterString);
	document.getElementById('diffLink_' + stringID).innerHTML = "";
}

/*
function togglekSearchSelection(chkChecker, stringID)
{
	if(chkChecker.checked)
	{
		document.getElementById('tr_search_' + stringID).style.backgroundColor = "#cccccc";
	} 
	else
	{
		document.getElementById('tr_search_' + stringID).style.backgroundColor = "transparent";
	}
}
*/

/* CHECKBOX SELECTION FUNCTIONS */

// Check search-result checkboxes where match is "identical" and translation is empty
// uncheck: if true, unckeck ALL search-result checboxes
function checkGuesses(uncheck)
{
	var tbl = document.getElementById("tblGuesses");
	if(tbl == null)
	{
		return; // No search results table visible
	}

	var trs = tbl.getElementsByTagName("TR");

	// Loop on table rows
	for(var r = 0; r < trs.length; r++)
	{
		var tds = trs[r].getElementsByTagName("TD");

		// Not TH line?
		if(tds.length > 0)
		{

			// Get checkbox from first cell
			var chks = tds[0].getElementsByTagName("INPUT");
			var percentTD = tds[1];
			var translationTD = tds[4];

			// Row has checkbox?
			if(chks.length > 0)
			{
				var chk = chks[0];

				if(uncheck)
				{
					// Uncheck all
					chk.checked = false;
				}
				else if(percentTD.className == "guess-identical" && translationTD.innerHTML == "")
				{
					// Check identical and not translated
					chk.checked = true;
				}
				else
				{
					// Uncheck not identical, or translated
					chk.checked = false;
				}

			}
		}
	}
}

/* STACK RELATED FUNCTIONS */

// Push current string id to the stack for later editing
function pushToStack(stringID)
{
	var stackVar = document.getElementById('xStringStack');
	if(stackVar.value != "")
	{
		stackVar.value += ",";
	}
	stackVar.value += stringID;
	
	// Update the stack number list view
	showStack();

}

// Pop the latest string ID from the stack for editing now
function popFromStack()
{
	var stringVar = document.getElementById('xStringID');
	var stackVar = document.getElementById('xStringStack');
	
	if(stackVar.value.length == 0)
	{
		alert("String stack is emtpy.");
		return;
	}

	// Take next or one entry from stack with regexps
	rx1 = new RegExp('^\(.*\),\([0-9]+\)$'); // multiple values with comma
	rx2 = new RegExp('^\([0-9]+\)$'); // one single value
	if(stackVar.value.match(rx1))
	{
		// Multiple values
		var newID = stackVar.value.replace(rx1, "$2");
		var newStack = stackVar.value.replace(rx1, "$1");
	}
	else if(stackVar.value.match(rx2))
	{
		// One single ID in stack
		var newID = stackVar.value;
		var newStack = "";
	}
	
	__TriggerEvent('editstring', true, 'xStringID', newID, 'xStringStack', newStack);
}

// Clear stack contents
function clearStack()
{
	var stackVar = document.getElementById('xStringStack');
		
	if(stackVar.value.length == 0)
	{
		alert("String stack is emtpy.");
		return;
	}


	if(confirm("Clear stack?"))
	{
		stackVar.value = "";
		showStack();
	}
	
}

// Display stack info next to the buttons
function showStack()
{
	// Get stack, mark page load time part, remove last comma, add spaces for linebreaking
	var stackVar = document.getElementById('xStringStack');
	var pageLoadStack = document.getElementById('htmlPageLoadStack');
	rx = new RegExp("\(^" + pageLoadStack.value + "\)");
	stackString = stackVar.value;
	stackString = stackString.replace(rx, '<span class="oldstack">$1</span>');
	stackString = stackString.replace(/,/g,", ");

	// Display it
	var stackView = document.getElementById('plhStackView');
	stackView.innerHTML = stackString;

	// Enable/Disable the "save+pop" and "Save to all stack" buttons
	var btnSavePop = document.getElementById('btnSavePopStack');
	if(btnSavePop)
	{
		if(stackVar.value != "")
		{
			btnSavePop.disabled = false;
			btnSavePop.className = "button";
		}
		else
		{
			btnSavePop.disabled = true;
			btnSavePop.className = "button-disabled";
		}
	}
}

// Call the save current string to all stacked IDs function if confirmed and valid
function callSaveToAllStack()
{
	stackVar = document.getElementById('xStringStack');
	
	if(stackVar.value.length == 0)
	{
		alert("String stack is emtpy.");
		return;
	}
	
	if(confirm("Operation will OVERWRITE all strings in the stack and current string!"))
	{
		__TriggerEvent('savetoallstack', false);
	}
}

